<template>
  <div id="dash-board">
    <v-app id="inspire">
      <v-card>
        <v-toolbar flat color="blue" dark>
          <v-toolbar-title>Administracion</v-toolbar-title>
        </v-toolbar>
        <v-tabs vertical>
          <v-tab color="green">
            <v-icon left>mdi-account</v-icon>Configuracion de categorias
          </v-tab>
          <v-tab> <v-icon left>mdi-lock</v-icon>Gestion de Productos </v-tab>
          <v-tab>
            <v-icon left>mdi-access-point</v-icon>gestion de carruseles
          </v-tab>
          <v-tab>
            <v-icon left>mdi-access-point</v-icon>Estadísticas de La Página
          </v-tab>
          <v-tab>
            <v-icon left>mdi-access-point</v-icon>Añadir Productos
          </v-tab>

          <v-tab-item>
            <v-card flat>
              <v-card-text>
                <CategoriesConfigurationPage id="CategoriesConfigurationPage" />
              </v-card-text>
            </v-card>
          </v-tab-item>
          <v-tab-item>
            <v-card flat>
              <v-card-text>
                <ProductsManagementPage
                  id="ProductsManagementPage"
                  class="grid"
                  :actualUserRole="actualUserRole"
                  :idActualUser="idActualUser"
                />
              </v-card-text>
            </v-card>
          </v-tab-item>
          <v-tab-item>
            <v-card flat>
              <v-card-text>
                <LastProductConfiguration
                  id="LastProductConfiguration"
                  :actualLimitation="actualLimitation"
                  @update-last-product-limitacion="saveLastProductNewLimitation"
                />
              </v-card-text>
            </v-card>
          </v-tab-item>
          <v-tab-item>
            <v-card flat>
              <v-card-text>
                <PageStatistics :categoriesData="categoriesData" />
              </v-card-text>
            </v-card>
          </v-tab-item>
          <v-tab-item>
            <v-card flat>
              <v-card-text>
                <FormProductPage
                  :idActualUser="idActualUser"
                  :actualUserRole="actualUserRole"
                />
              </v-card-text>
            </v-card>
          </v-tab-item>
        </v-tabs>
      </v-card>
    </v-app>
  </div>
</template>

<script>
import CategoriesConfigurationPage from '@/components/CategoryConfigurationPage/CategoriesConfigurationPage.vue'
import ProductsManagementPage from '@/components/ProductsManagement/ProductsManagementPage.vue'
import LastProductConfiguration from '@/components/DashBoard/LastProductConfiguration.vue'
import PageStatistics from '@/components/DashBoard/PageStatistics.vue'
import FormProductPage from '@/components/AddProduct/FormProductPage.vue'
import API from '@/API.js'

export default {
  name: 'AdashBoardPage',
  components: {
    CategoriesConfigurationPage,
    ProductsManagementPage,
    LastProductConfiguration,
    PageStatistics,
    FormProductPage
  },
  data() {
    return {
      idActualUser: '',
      actualUserRole: '',
      actualLimitation: [],
      categoriesData: []
    }
  },
  async mounted() {
    this.idActualUser = this.$route.params.idActualUser
    this.actualUserRole = await API.getIdActualUser(this.idActualUser)

    this.uploadActualLimitation()
    this.uploadCategoriesData()
  },

  methods: {
    async uploadActualLimitation() {
      this.actualLimitation = await API.uploadActualLimitation()
    },

    async uploadCategoriesData() {
      this.categoriesData = await API.uploadCategoriesData()
    },

    async saveLastProductNewLimitation(newLimitation) {
      await API.saveLastProductNewLimitation(newLimitation)
      this.uploadActualLimitation()
    }
  }
}
</script>

//
<style>
/* .grid {
  display: grid;
  grid-template-columns: repeat(auto-fill, minmax(200px, 1fr));
  row-gap: 16rem;
  column-gap: 12rem;
  place-items: center;
}

.grid > div {
  padding: 1rem;
  display: grid;
  place-items: center;
}
.grid > div::before {
  content: '';
  padding-top: 100%;
  display: block;
  grid-area: 1 / 1 / 2 / 2;
} */
</style>
